import type {
  Edge,
  EdgeAddChange,
  EdgeChange,
  EdgeSelectionChange,
  ElementChange,
  FlowElement,
  FlowElements,
  GraphEdge,
  GraphNode,
  Node,
  NodeAddChange,
  NodeChange,
  NodeSelectionChange,
} from '../types'
export declare const applyChanges: <
  T extends Node<any> | Edge<any> | FlowElement<any> = Node<any>,
  C extends ElementChange = T extends GraphNode<any> ? NodeChange : EdgeChange,
>(
  changes: C[],
  elements: T[],
) => T[]
export declare const applyEdgeChanges: (changes: EdgeChange[], edges: GraphEdge[]) => GraphEdge<any>[]
export declare const applyNodeChanges: (changes: NodeChange[], nodes: GraphNode[]) => GraphNode<any>[]
export declare const createSelectionChange: (id: string, selected: boolean) => NodeSelectionChange | EdgeSelectionChange
export declare const createAdditionChange: <
  T extends GraphNode<any> | GraphEdge<any> = GraphNode<any>,
  C extends EdgeAddChange<any> | NodeAddChange<any> = T extends GraphNode<any> ? NodeAddChange<any> : EdgeAddChange<any>,
>(
  item: T,
) => C
export declare const getSelectionChanges: (items: FlowElements<any>, selectedIds: string[]) => NodeSelectionChange[]
